CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  NOT_A_NUMBER = $7FFF_FFFF

VAR

  long attenuation


OBJ

  Pst : "Parallax Serial Terminal"
  F32 : "F32_160222a"                        ' uses one cog
  FMath : "FloatString160226a" ' Needed for floating point input and output.

PUB Init

  F32.Start
  Pst.Start(115200)

  repeat
    result := Pst.RxCount
    Pst.Str(String(11, 13, "Press Any Key to Start"))
    waitcnt(clkfreq / 2 + cnt)
  until result

  Pst.RxFlush

  MainLoop

PUB MainLoop


  repeat
    Pst.Str(String(11, 13, 11, 13, "Attentuation Control "))
    Pst.Str(String(11, 13, "Enter desired level of attenuation: "))
    attenuation := GetFloatInput

    Pst.Str(String(11, 13, "attenuation = "))
    Pst.Str(FMath.FloatToString(attenuation))


PUB GetFloatInput | leftOfDec, rightOfDec, inputCharacter, sideOfDecimal, {
} negativeFlag, rightSideDivisor, exponentFlag, exponent, parameterReceivedFlag, timeout

  negativeFlag := 0
  exponentFlag := 0
  rightSideDivisor := 1
  sideOfDecimal := 0 ' zero for left and one for right
  ' use trick leftOfDec[1] is the same variable as rightOfDec
  leftOfDec := 0
  leftOfDec[1] := 0 ' same as rightOfDec := 0
  repeat

    inputCharacter := Pst.CharIn

    if inputCharacter => "0" and inputCharacter =< "9"    'Checking for numbers 0-9 extract and parameters values
      leftOfDec[sideOfDecimal] *= 10                                      'to shift over one digiit
      leftOfDec[sideOfDecimal] += inputCharacter - "0"                       'this converts from ASCII to numeric..
      parameterReceivedFlag := 1                        ' now we have a number so set flag
      if sideOfDecimal ' if on the right side of decimal keep track of size
        rightSideDivisor *= 10
    elseif inputCharacter == "-"                        ' check for neg flag to make a neg number later if we need
      negativeFlag := 1                                 'a negative sign anywhere in string will set flag
    elseif inputCharacter == "."
      sideOfDecimal := 1
    if inputCharacter == "e" or inputCharacter == "E"
      exponentFlag := 1

  while inputCharacter <> 13 and exponentFlag == 0

  if negativeFlag
    -leftOfDec
    -rightOfDec

  if leftOfDec
    result := F32.FFloat(leftOfDec)
  else
    result := 0.0

  if rightSideDivisor > 1
    rightOfDec := F32.FFloat(rightOfDec)
    rightSideDivisor := F32.FFloat(rightSideDivisor)
    rightOfDec := F32.FDiv(rightOfDec, rightSideDivisor)
    result := F32.FAdd(result, rightOfDec)

  if exponentFlag
    exponent := Pst.DecIn
    if exponent == NOT_A_NUMBER
      result := NOT_A_NUMBER

    else
      exponent := F32.FFloat(exponent)
      exponent := F32.Pow(10.0, exponent)
      result := F32.FMul(result, exponent)
